include "Zeropage.inc"
include "Vram.inc"
include "Chars.inc"

ext BackgroundPattern_, FortPattern_
ext CharOffset_, DotOffset_
ext FortDotOffset_, FortCharOffset_

BackgroundPatternRam0 equ CharPatternRam+CharSize*Char_Background
BackgroundPatternRam1 equ BackgroundPatternRam0+CharSize*(Char_Background_End-Char_Background)/2

FortPatternRam0 equ CharPatternRam+CharSize*Char_Fort
FortPatternRam1 equ FortPatternRam0+CharSize*(Char_Fort_End-Char_Fort)/2

FortWidth equ 8
FortHeight equ 4

pSource equ ZW0
pDestination equ ZW1
xCount equ ZB0
yCount equ ZB1
leftByte equ ZB2
rightByte equ ZB3


; void RollChar();
dseg
groundBytes:
    defs CharHeight*(Char_Background_End-Char_Background)/2
cseg
RollChar_: public RollChar_
    pha
        lda #low BackgroundPattern_ | sta <pSource
        lda #high BackgroundPattern_ | sta <pSource+1

        ldy #0
        ldx #0
        do
            lda BackgroundPattern_,y | iny
            sta <leftByte
            lda BackgroundPattern_,y | iny
            sta <rightByte

            defb $da ; phx
                ldx DotOffset_
                do
                while ne
                    asl <rightByte | rol <leftByte
                    dex
                wend
            defb $fa ; plx
            lda <leftByte
            sta groundBytes,x | inx
            
            cpx #CharHeight*(Char_Background_End-Char_Background)/2
        while ne | wend

        sei
            defb $03,$00 ; st0
            lda CharOffset_
            if eq
                lda #low BackgroundPatternRam0 | sta >$0002
                lda #high BackgroundPatternRam0 | sta >$0003
            else
                lda #low BackgroundPatternRam1 | sta >$0002
                lda #high BackgroundPatternRam1 | sta >$0003
            endif

            ldx #0
            do
                defb $da ; phx
                    ldy #CharHeight
                    do
                        lda groundBytes,x | inx
                        defb $03,$02 ; st0
                        sta >$0002
                        sta >$0003
                        dey
                    while ne | wend
                defb $fa ; plx
                ldy #CharHeight
                do
                    lda groundBytes,x | inx
                    defb $03,$02 ; st0
                    defb $13,$00 ; st1
                    sta >$0003
                    dey
                while ne | wend
                cpx #CharHeight*(Char_Background_End-Char_Background)/2
            while ne | wend
        cli
    pla
rts


; void SetFortChars();
zseg
leftOffset:
    defb 0
rightOffset:
    defb 0
dseg
fortBytes:
    defs CharHeight*4
cseg
SetFortChars_: public SetFortChars_
    pha
        lda #low FortPattern_ | sta <pSource
        lda #high FortPattern_ | sta <pSource+1

        lda FortCharOffset_
        if eq
            lda #low FortPatternRam0 | sta <pDestination
            lda #high FortPatternRam0 | sta <pDestination+1
        else
            lda #low FortPatternRam1 | sta <pDestination
            lda #high FortPatternRam1 | sta <pDestination+1
        endif

        lda #FortWidth | sta <xCount
        do
            lda #0 | sta <leftOffset
            lda #CharHeight*4*FortHeight | sta <rightOffset
            lda #FortHeight | sta <yCount
            do
                ldx #0
                do
                    ldy <leftOffset
                    lda (<pSource),y | sta <leftByte
                    iny | sty <leftOffset

                    ldy <rightOffset
                    lda (<pSource),y | sta <rightByte
                    iny | sty <rightOffset

                    ldy FortDotOffset_
                    do
                    while ne
                        asl <rightByte | rol <leftByte
                        dey
                    wend

                    lda <leftByte | sta fortBytes,x
                    inx
                    cpx #CharHeight*4
                while ne | wend

                sei
                    defb $03,$00 ; st0
                    lda <pDestination | sta >$0002
                    lda <pDestination+1 | sta >$0003

                    ldx #0
                    do
                        defb $03,$02 ; st0
                        lda fortBytes,x | inx
                        sta >$0002
                        lda fortBytes,x | inx
                        sta >$0003
                        cpx #CharHeight*4
                    while ne | wend
                cli

                lda <pDestination | clc|adc #CharSize*FortWidth | sta <pDestination
                lda <pDestination+1 | adc #0 | sta <pDestination+1

                dec <yCount
            while ne | wend

            lda <pSource | clc|adc #CharHeight*4*FortHeight | sta <pSource
            lda <pSource+1 | adc #0 | sta <pSource+1

            lda <pDestination | clc|adc #low(CharSize*(-FortWidth*FortHeight+1)) | sta <pDestination
            lda <pDestination+1 | adc #high(CharSize*(-FortWidth*FortHeight+1)) | sta <pDestination+1

            dec <xCount
        while ne | wend
    pla
rts
